;--------------------------------------------------------------------------------
;
; Blue Screen of Death -- (C) September 27, 2006 -- Dr. William T. Verts
; with Turbo Assembler 2.0
;
; This version sets the screen to 320x200 Graphics, paints
; a blue screen with a white border, and then waits for
; a keypress of the ESCAPE key to switch back to text mode
; and exit (allowing reasonable behavior under Windows).
;
;--------------------------------------------------------------------------------

		DOSSEG
		.MODEL	SMALL
		.STACK	100H

;--------------------------------------------------------------------------------

ESCAPE		EQU	27			; ASCII Character
BLUE		EQU	0101H			; VGA Color * 2
WHITE		EQU	0F0FH			; VGA Color * 2

;--------------------------------------------------------------------------------

		.CODE
		MOV	AX,@DATA		; Set DS to point to the
		MOV	DS,AX			; DATA segment

;--------------------------------------------------------------------------------

		MOV	AX,0013H		; Set screen to Graphics 320x200
		INT	10H			; Call Function

;--------------------------------------------------------------------------------

		MOV	AX,0A000H		; Set up VGA Segment Address
		MOV	ES,AX			; in ES

		MOV	AX,BLUE			; AX := BLUE-BLUE (2 pixels)

		MOV	CX,32000		; Paint Entire VGA Screen
		MOV	DI,0			; Starting at Pixel(0,0)
		REP STOSW			; (64000 bytes = 32000 words)

		MOV	AX,WHITE		; AX := WHITE-WHITE (2 pixels)

		MOV	CX,160			; Paint Top Line
		MOV	DI,0			; Starting at Pixel(0,0)
		REP STOSW			; (320 bytes = 160 words)

		MOV	CX,160			; Paint Bottom Line
		MOV	DI,63680		; Starting at Pixel(0,199)
		REP STOSW			; (320 bytes = 160 words)

		MOV	CX,200			; Paint Left Line
		MOV	BX,0			; Starting at Pixel(0,0)
LeftSide:	MOV	[ES:BX],AL		;
		ADD	BX,320			;
		LOOP	LeftSide		;

		MOV	CX,200			; Paint Right Line
		MOV	BX,319			; Starting at Pixel(319,0)
RightSide:	MOV	[ES:BX],AL		;
		ADD	BX,320			;
		LOOP	RightSide		;

;--------------------------------------------------------------------------------

Pause:		MOV	AX,0700H		; AL := ReadKey (no ^C check)
		INT	21H			;
		CMP	AL,ESCAPE		; Is Key = ESC ?
		JNE	Pause			;

;--------------------------------------------------------------------------------

		MOV	AX,0003H		; Reset screen to Text, 80x25
		INT	10H			; Call Function

		MOV	AH,4CH			; DOS "Terminate Program" Function
		INT	21H			; Call Function

		END
