;--------------------------------------------------------------------------------
;
; Blue Screen of Death -- (C) September 27, 2006 -- Dr. William T. Verts
; with Turbo Assembler 2.0
;
; This version sets the screen to 320x200 Graphics, paints
; a blue screen with a white border, and then waits for
; a keypress of the ESCAPE key to switch back to text mode
; and exit (allowing reasonable behavior under Windows).
;
;--------------------------------------------------------------------------------

		DOSSEG
		.MODEL	SMALL
		.STACK	100H

;--------------------------------------------------------------------------------

ESCAPE		EQU	27			; ASCII Character
BLUE		EQU	1			; VGA Color
WHITE		EQU	15			; VGA Color

;--------------------------------------------------------------------------------

		.CODE
		MOV	AX,@DATA		; Set DS to point to the
		MOV	DS,AX			; DATA segment

;--------------------------------------------------------------------------------

		MOV	AX,0013H		; Set screen to Graphics 320x200
		INT	10H			; Call Function

;--------------------------------------------------------------------------------

		MOV	AX,0A000H		; Set up VGA Segment Address
		MOV	ES,AX			; in ES

		MOV	AL,BLUE			; AL := BLUE (one pixel)

		MOV	CX,64000		; Paint Entire VGA Screen
		MOV	BX,0			;
Blue_Loop:	MOV	[ES:BX],AL		;
		ADD	BX,1			;
		SUB	CX,1			;
		JNE	Blue_Loop		;

		MOV	AL,WHITE		; AL := WHITE (1 pixel)

		MOV	BX,0			; Starting at Pixel(0,0)
		MOV	CX,320			; Paint Top Line
TopSide:	MOV	[ES:BX],AL		;
		ADD	BX,1			;
		SUB	CX,1			;
		JNE	TopSide			;

		MOV	BX,63680		; Starting at Pixel(0,199)
		MOV	CX,320			; Paint Bottom Line
BottomSide:	MOV	[ES:BX],AL		;
		ADD	BX,1			;
		SUB	CX,1			;
		JNE	BottomSide		;

		MOV	BX,0			; Starting at Pixel(0,0)
		MOV	CX,200			; Paint Left Line
LeftSide:	MOV	[ES:BX],AL		;
		ADD	BX,320			;
		SUB	CX,1			;
		JNE	LeftSide		;

		MOV	BX,319			; Starting at Pixel(319,0)
		MOV	CX,200			; Paint Right Line
RightSide:	MOV	[ES:BX],AL		;
		ADD	BX,320			;
		SUB	CX,1			;
		JNE	RightSide		;

;--------------------------------------------------------------------------------

Pause:		MOV	AX,0700H		; AL := ReadKey (no ^C check)
		INT	21H			;
		CMP	AL,ESCAPE		; Is Key = ESC ?
		JNE	Pause			;

;--------------------------------------------------------------------------------

		MOV	AX,0003H		; Reset screen to Text, 80x25
		INT	10H			; Call Function

		MOV	AH,4CH			; DOS "Terminate Program" Function
		INT	21H			; Call Function

		END
